
/* Original source code by Paul B Mann with tabs = 3 */

		#include "lr1_main.h"
		#include "lr1_parser.h"
  		#include "lr1_actions.h"          

#ifdef TOKEN_ACTIONS

///////////////////////////////////////////////////////////////////////////////
//                                                                           // 
//    error     																				  //

int   lr1_token_action::error (short t)                     
{
	// Illegal character?
		if (token.end == token.start) 
		{
			token.end++;
			return (t); // Return zero (t should be zero).
		}
	// Do a symbol table lookup.
	// Could be a valid keyword or constant from an ambiguous grammar.
		return (lookup (t)); 
}

///////////////////////////////////////////////////////////////////////////////
//                                                                           // 
//    lookup    																				  //

int   lr1_token_action::lookup (short t) // Look for Symbol.
{
//		int a = tact_arg[t];
		token.sti = add_symbol (t, token.start, token.end); 
		return (symbol[token.sti].term); // This works for {typedef}
}

#endif
#ifdef PARSE_ACTIONS

///////////////////////////////////////////////////////////////////////////////
//                                                                           // 
//    defterm   																				  //

short lr1_parse_action::defterm (short p) 
{
	   short i = pact_arg[p];				   // Get first argument index.
      short sti = PS [arg_numb[i]-1].sti; // Get sti for first argument.
      symbol[sti].term = arg_numb [i+1];  // Set term to second argument.
      return (0);
}

#endif
#ifdef NODE_ACTIONS

///////////////////////////////////////////////////////////////////////////////
//                                                                           // 
//    goal_ (not used, for testing only)												  //

short lr1_node_action::goal_ (int n)
{
		return (0);
}

#endif

/*--- End of Actions. -------------------------------------------------------*/

























